diff --git a/src/modules/system/system.c b/src/modules/system/system.c
index a48520d95..821412a02 100644
--- a/src/modules/system/system.c
+++ b/src/modules/system/system.c
@@ -822,6 +822,11 @@ ecs_entity_t ecs_new_system(
         EcsSignatureExpr *ptr = ecs_get_mut(world, result, EcsSignatureExpr, NULL);
         ecs_assert(ptr != NULL, ECS_INTERNAL_ERROR, NULL);
 
+        if (!ptr->expr || !signature) {
+            if (ptr->expr != signature) {
+                ecs_abort(ECS_ALREADY_DEFINED, NULL);
+            } 
+        } else
         if (strcmp(ptr->expr, signature)) {
             ecs_abort(ECS_ALREADY_DEFINED, name);
         }
diff --git a/test/api/project.json b/test/api/project.json
index 99c1a2349..abb4c0e15 100644
--- a/test/api/project.json
+++ b/test/api/project.json
@@ -514,7 +514,9 @@
                 "system_readeactivate",
                 "system_readeactivate_w_2_systems",
                 "add_to_system_in_progress",
-                "add_to_lazy_system_in_progress"
+                "add_to_lazy_system_in_progress",
+                "redefine_null_signature",
+                "redefine_0_signature"
             ]
         }, {
             "id": "Sorting",
diff --git a/test/api/src/SystemMisc.c b/test/api/src/SystemMisc.c
index 31832529c..55b3bfdff 100644
--- a/test/api/src/SystemMisc.c
+++ b/test/api/src/SystemMisc.c
@@ -1080,3 +1080,34 @@ void SystemMisc_add_to_lazy_system_in_progress() {
 
     ecs_fini(world);
 }
+
+static
+void Action(ecs_iter_t *it) { }
+
+void SystemMisc_redefine_null_signature() {
+    ecs_world_t *world = ecs_init();
+
+    ecs_entity_t s_1 = ecs_new_system(
+        world, 0, "System", EcsOnUpdate, NULL, Action);
+
+    ecs_entity_t s_2 = ecs_new_system(
+        world, 0, "System", EcsOnUpdate, NULL, Action);        
+
+    test_assert(s_1 == s_2);
+
+    ecs_fini(world);
+}
+
+void SystemMisc_redefine_0_signature() {
+    ecs_world_t *world = ecs_init();
+
+    ecs_entity_t s_1 = ecs_new_system(
+        world, 0, "System", EcsOnUpdate, "0", Action);
+
+    ecs_entity_t s_2 = ecs_new_system(
+        world, 0, "System", EcsOnUpdate, "0", Action);
+
+    test_assert(s_1 == s_2);
+
+    ecs_fini(world);
+}
diff --git a/test/api/src/main.c b/test/api/src/main.c
index 7aada2e94..eb0a09ef7 100644
--- a/test/api/src/main.c
+++ b/test/api/src/main.c
@@ -465,6 +465,8 @@ void SystemMisc_system_readeactivate(void);
 void SystemMisc_system_readeactivate_w_2_systems(void);
 void SystemMisc_add_to_system_in_progress(void);
 void SystemMisc_add_to_lazy_system_in_progress(void);
+void SystemMisc_redefine_null_signature(void);
+void SystemMisc_redefine_0_signature(void);
 
 // Testsuite 'Sorting'
 void Sorting_sort_by_component(void);
@@ -2916,6 +2918,14 @@ bake_test_case SystemMisc_testcases[] = {
     {
         "add_to_lazy_system_in_progress",
         SystemMisc_add_to_lazy_system_in_progress
+    },
+    {
+        "redefine_null_signature",
+        SystemMisc_redefine_null_signature
+    },
+    {
+        "redefine_0_signature",
+        SystemMisc_redefine_0_signature
     }
 };
 
@@ -5846,7 +5856,7 @@ static bake_test_suite suites[] = {
         "SystemMisc",
         NULL,
         NULL,
-        51,
+        53,
         SystemMisc_testcases
     },
     {
